
#include "prehtml.h"

const char *listefonctions[]={
	"shell","echo","echonoesc","tag",
	"shellecho","shellechonoesc",
	"chut","/chut","error","warning","rem",    /* commandes immdiates*/
	"if","else","elif","fi","for","while","done", 
	"include","notinclude","reinclude",  /* commandes imbriques*/
	"generate","/generate", /* pas immdiates, mais pas imbricables */
	"body","/body",   /* pour l'inclusion du corps seul, sans enttes */
	NULL                    /* c'est tout!*/
};
static int a_decoder; /* vrai si fonction type "&lt;if"*/
static int a_decoder_link; /* vrai si fonction type "%3Cecho%20$lien%3E" */

string chaine; /* chaine qui suit le code de la fonction */
string fonction; /* nom de la fonction */

static struct{char c,code[7];} escape[]={
	{'"',"quot"}, /* le recodage est facultatif */
	{'&',"amp"},
	{'<',"lt"},
	{'>',"gt"},
	{' ',"nbsp"}, /* seulement dcoder, pas recoder */
	{'',"iexcl"},
	{'',"cent"},
	{'',"pound"},
	{'',"euro"}, // a, c'est en fait du iso-8859-15 et non -1 (sinon ce serait "curren")
	{'',"yen"},
	{'',"brvbar"},
	{'',"sect"},
	{'',"uml"},
	{'',"copy"},
	{'',"ordf"},
	{'',"laquo"},
	{'',"not"},
	{'',"shy"},
	{'',"reg"},
	{'',"macr"},
	{'',"deg"},
	{'',"plusmn"},
	{'',"sup2"},
	{'',"sup3"},
	{'',"acute"},
	{'',"micro"},
	{'',"para"},
	{'',"middot"},
	{'',"cedil"},
	{'',"sup1"},
	{'',"ordm"},
	{'',"raquo"},
	{'',"frac14"},
	{'',"frac12"},
	{'',"frac34"},
	{'',"iquest"},
	{'',"Agrave"},
	{'',"Aacute"},
	{'',"Acirc"},
	{'',"Atilde"},
	{'',"Auml"},
	{'',"Aring"},
	{'',"AElig"},
	{'',"Ccedil"},
	{'',"Egrave"},
	{'',"Eacute"},
	{'',"Ecirc"},
	{'',"Euml"},
	{'',"Igrave"},
	{'',"Iacute"},
	{'',"Icirc"},
	{'',"Iuml"},
	{'',"ETH"},
	{'',"Ntilde"},
	{'',"Ograve"},
	{'',"Oacute"},
	{'',"Ocirc"},
	{'',"Otilde"},
	{'',"Ouml"},
	{'',"times"},
	{'',"Oslash"},
	{'',"Ugrave"},
	{'',"Uacute"},
	{'',"Ucirc"},
	{'',"Uuml"},
	{'',"Yacute"},
	{'',"THORN"},
	{'',"szlig"},
	{'',"agrave"},
	{'',"aacute"},
	{'',"acirc"},
	{'',"atilde"},
	{'',"auml"},
	{'',"aring"},
	{'',"aelig"},
	{'',"ccedil"},
	{'',"egrave"},
	{'',"eacute"},
	{'',"ecirc"},
	{'',"euml"},
	{'',"igrave"},
	{'',"iacute"},
	{'',"icirc"},
	{'',"iuml"},
	{'',"eth"},
	{'',"ntilde"},
	{'',"ograve"},
	{'',"oacute"},
	{'',"ocirc"},
	{'',"otilde"},
	{'',"ouml"},
	{'',"divide"},
	{'',"oslash"},
	{'',"ugrave"},
	{'',"uacute"},
	{'',"ucirc"},
	{'',"uuml"},
	{'',"yacute"},
	{'',"thorn"},
	{'',"yuml"},
	{'\0',""}};

string recodeHTML(string &s){ // fait les chappements HTML
	string ligne;
	int in=0,i,car;
	while((car=s[in])){
		if (a_decoder_link){ // recodage de type "liens"
			// la ligne suivante servait  coder les espaces en '+', mais je l'ai enleve
			/*if (car==' ') {car='+'; ligne += car;} // codage spcial des espaces
		else */if (car<=0x22 || (car >=0x25 && car<0x29) || car==0x2b || car==0x3c || car==0x3e ||
		           car==0x5b || car==0x5d || car==0x5e || car==0x60 || car>=0x7b){
			//	liste des caractres  chapper:
			// <20,   20' ', 21 22 '!"', 25'%', 26??? '&', 27 28 29 ''()', 2B'+', 3c 3e '<>',
			// 5b 5d 5e '[]^', 60 '`', 7b 7c 7d 7e 7f '{|}~DEL', >=80
			ligne += '%';
			i=(car & 0xF0)>>4;
			ligne += (i<10?'0'+i:'A'+i-10);
			i=(car & 0xF);
			ligne += (i<10?'0'+i:'A'+i-10);
		} else // caractre normal
				ligne += car;
		} else { // recodage normal, type "HTML"
			for(i=0;escape[i].c;i++){
				if (escape[i].c==car)
					if (car!='"' && car!=' ' &&  // ne pas recopier ces caractres
					    (((escape[i].c&0x80)==0) || (!bits8)))  // ne pas coder les caractres 8 bits si option 8 bits
					    break;
			}
			if (escape[i].c){ /* on a trouv un caractre  chapper */
				ligne += '&';
				ligne += escape[i].code;
				ligne += ";";
			}
			else{
				/* Ce n'est pas un caractre  coder spcialement: */
				/*   regardons si c'est _lt_, _gt_, ou _und_ */
				if (car=='_'){
					if (!s.compare(in,4,"_lt_")){
						in+=3;car='<';
					}else if (!s.compare(in,4,"_gt_")){
						in+=3;car='>';
					}else if (!s.compare(in,5,"_und_")){
						in+=4;car='_';
					}
				}
				ligne += car;
			}
		}
		in++;
	}
	return ligne;
}

void nettoiechaine(void){ /* si a_decode, traduit les codes HTML de chaine;
	 * de toute faon enlve le > final et les \n */
	size_t pchaine=0,
	p2chaine=0;
	string chaine2;
	char code[40];
	int i;
	char c;

	/* vrifie qu'on a bien <... > ou &lt;...&gt; */ 
	/* non non, je ne vrifie pas, car Netscape Composer fait
	 * presque toujours des &gt;.....>
	 * C'est laid, mais Netscape Composer le fait et je l'utilise */
	//  if (a_decoder && chaine[strlen(chaine)-1]=='>')
	//    warning("commande \"<%s\" en HTML se termine par >",
	//	    fonction);
	//  if ((!a_decoder) && chaine[strlen(chaine)-1]!='>')
	//    warning("Attention: commande \"<%s\" en ASCII ne se termine pas par >\n",
	//	    fonction);

	/* dcode les chappements de liens %xx */
	if (a_decoder_link){
		// remplacement des "+" par des espaces " "
		for(pchaine=0; pchaine!=string::npos; pchaine=chaine.find('+',pchaine)) chaine[pchaine] = ' ';
		// plus remplacement des %xx par ce qu'il faut
		for(pchaine=0; pchaine!=string::npos; pchaine=chaine.find('%',pchaine)){
			if (strchr("0123456789abcdefABCEDF",chaine[pchaine+1]))
				if (strchr("0123456789abcdefABCEDF",chaine[pchaine+2])){
					sscanf(chaine.c_str()+pchaine+1,"%2X",&i);
					chaine[pchaine]=i;
					chaine.erase(pchaine+1,2);
				}
			pchaine++;
			a_decoder=0;
		}
	}

	/* dcode les chappements HTML, sauf si dj codage de type "liens" */
	else a_decoder=1; /* ON MET TOUJOURS  DCODER, C'EST ENCORE LE PLUS PRATIQUE */
	if (a_decoder) while ((pchaine=chaine.find('&', pchaine))!=string::npos){
		p2chaine=chaine.find(';',pchaine);
		if (p2chaine==string::npos || (p2chaine-pchaine)>=39){ /* pas de ; ou trop long*/
			pchaine++;
			continue;
		}
		memmove(code,chaine.c_str()+pchaine+1,p2chaine-pchaine-1);
		code[p2chaine-pchaine-1]='\0';
		for(i=0;escape[i].c;i++)
			if (!strcmp(code,escape[i].code)){
				if ((escape[i].c & 0x80)==0 || bits8==0 || bits8==1){ // car. 7 bits ou codage latin1 => 1 seul car.
					chaine[pchaine]=escape[i].c;
					chaine.erase(pchaine+1,p2chaine+1-(pchaine+1));
				} else { // car. 8 bits et codage UTF-8 => 2 ou 3 car.
					if (escape[i].c==''){ // seul cas non iso-8859-1, cod en 3 octets
						chaine[pchaine++]=0xe2;
						chaine[pchaine++]=0x82;
						chaine[pchaine]=0xac;
					} else { // car. iso-8859-1 => 2 octets
						chaine[pchaine++]=0xC0 | (((unsigned char)escape[i].c) >> 6);
						chaine[pchaine]=0x80 | (escape[i].c & 0x3F);						
					}
				}
				break;
			}
		pchaine++;
	}

	/* remplace les '\n' par ' ' */
	for (i=0;chaine[i];i++) if (chaine[i]=='\n') chaine[i]=' ';

	/* on devrait avoir un '>'  la fin, et on l'enlve, ou sinon on signale l'erreur (fatale)*/
	i=chaine.size()-1;
	if (chaine[i]=='>')
		chaine.erase(i);
	else {
		if (i>=3 && !chaine.compare(i-3,4,"&gt;")) chaine.erase(i-3);
		else {
			erreur("La commande <%s ne se termine pas par >",fonction.c_str());
		}
	}

	for(pchaine=0; pchaine<chaine.size(); pchaine++){
		c=chaine[pchaine];
		if (c=='_'){
			if ((!chaine.compare(pchaine,4,"_lt_")) ||
			    (!chaine.compare(pchaine,5,"_und_"))||
			    (!chaine.compare(pchaine,4,"_gt_")))
			{strcpy(code,"_und_");c='\0';}
		}
		else if (c=='<') {strcpy(code,"_lt_");c='\0';}    
		else if (c=='>') {strcpy(code,"_gt_");c='\0';}
		if (c) chaine2 += c;
		else chaine2 += code;
	}
	chaine=chaine2;
}


int decode(void){ /* renvoie un caractre, ou EOF si fini,
	 * ou EST_FONCTION si a trouv un fonction
	 * (ce qui demande de lire quelle_fonction() )*/
	int c,cmin,premiercar;
	int i;
	int html;
	premiercar=c=mongetc();
	if (premiercar=='&'){
		stocke(); /* c'est peut-tre le dbut de &lt; */
		i=0;
		if (mongetc()=='l')
			if (mongetc()=='t')
			if (mongetc()==';') i=1;
		if (!i) {
			destocke(); return c; /* dsol, c'tait une erreur */
		}
		a_decoder=1; /* a dmarre par &lt;, c'est donc du HTML */
		a_decoder_link=0;
	}
	else if (premiercar=='%'){
		stocke(); /* c'est peut-tre le dbut de &3C; */
		i=0;
		if (mongetc()=='3')
			if (strchr("cC",mongetc())) i=1;
		if (!i) {
			destocke(); return c; /* dsol, c'tait une erreur */
		}
		a_decoder=0;
		a_decoder_link=1;  /* a dmarre par %3C, c'est donc du codage de liens */
	}
	else if (premiercar=='<') {
		stocke();
		a_decoder=a_decoder_link=0; /* a dmarre par <, c'est donc du ASCII */
	}
	else return c; /* OK, c'est un caractre qui ne pose pas de question */
	/* si on est l, c'est qu'on a vu "<" ou "&lt;" ou %3C, et on stocke */
	/* on lit le nom de la fonction*/
	fonction.clear();
	for (i=0;i<29;i++){
		c=mongetc();
		if (i==0) 
			while (c==' ') c=mongetc(); /* on enlve les espaces aprs '<' */
		cmin=tolower(c);
		if (c!='/'&&(cmin<'a' || cmin>'z')) break; /*  '/' et minuscules */
		fonction += cmin; /* en minuscules SVP */
	}
	/* est-ce que a correspond  une fonction? */
	for(i=0;;i++){
		if (!listefonctions[i]){ /* on arrive sur NULL, a ne correspond pas*/
			destocke();
			return premiercar;
		}
		if (!fonction.compare(listefonctions[i])){
			/* on a trouv une fonction, mais attention, car si c'est <BODY> ou
			 * </BODY> et qu'on est dans le fichier principal, il faut la laisser
			 * (ainsi que si on est dans un <REINCLUDE> */
			/* si ce n'est pas "body" ni "/body", a va, je l'accepte */
			if ((fonction.compare("body") && fonction.compare("/body"))) break;
			/* si c'est dans un <REINCLUDE>, je n'accepte que </body> */
			if (flag_reinclude){
				if (!fonction.compare("/body")) break;
			}
			/* sinon, hors du fichier principal, j'accepte <body> et </body> */
			else if (fichier_courant->profondeur) break;
			/* autres cas: je l'ignore */
		}
	}
	/* OK, c'est donc la fonction i */
	finstocke(); /* on limine donc ce qu'on a stock '<fonction#" */
	chaine.clear();
	html=0; /* on n'est pas dans une balise HTML */
	while(1){
		if (c==EOF) erreur("EOF rencontr dans l'argument de <%s",fonction.c_str());
		chaine+=c;
		if (c=='<') html=1; /* on rentre dans une balise HTML*/
		if (c=='>'){
			if (html) html=0; /* on sort de la balise HTML */
			else break; /* fin de la commande prehtml */
			//    if (chaine[pchaine-1]=='>') break;
		}
		if (chaine.size()>=4 && a_decoder) if (!chaine.compare(chaine.size()-4,4,"&gt;")) 
			break; /* la commande prehtml peut galement se terminer ainsi */
		if (chaine.size()>=3 && a_decoder_link) if ((!chaine.compare(chaine.size()-3,3,"%3e")) || (!chaine.compare(chaine.size()-3,3,"%3E")))
			break;
		c=mongetc();
	}
	nettoiechaine();
	//printf("Fonction (codage \"%s\") <%s> avec l'argument '%s'\n",(a_decoder?"HTML":(a_decoder_link?"lien":"ASCII")),fonction,chaine);
	return EST_FONCTION;

}
