#include "prehtml.h"

#define NOMFINFICHIER "/tmp/prehtml_fingenerate_XXXXXX"
static char nomfinfichier[]=NOMFINFICHIER;

static vector<generate> generates;
int engenerate; /* 0=pas de gnrate, 1=dans gnrate
 * 2=/generate pass */

void init_generate(void){
	engenerate=0;
	generates.clear();
}

void remplitgenerate(const char *s){ /* partie commune  la 1re fois et aux autres*/
	generate gene;
	gene.nom = s;
	gene.nomtemp = string(s)+".tmp";
	creetemp(gene.nomtemp.c_str()); /* fichier  effacer si arrt d'urgence */
	sortie=fopen(gene.nomtemp.c_str(),"w");
	if (!sortie) erreur("<generate>: pas pu crer '%s'",gene.nomtemp.c_str());
	generates.push_back(gene);
}

void genere(const char *s){
	int i;
	generate *gene;
	if (!(*s)) erreur("<generate> avec une chane vide!");
	if (engenerate==1)erreur("Impossible de gnrer %s car on n'a pas"
	                         " referm le <generate> prcdent",s);
	else if (engenerate==0){ /* premier passage par <generate> */
		fclose(sortie); /* on ferme le fichier en cours, c'est le dbut de tous */
		engenerate=1;
		remplitgenerate(s);
	}
	else if (engenerate==2){ /* </generate> est pass, et on en fait un autre */
		/* d'abord, on vrifie que le nom donn n'a pas dj t donn par un
		 * <generate> prcedent */
		for (size_t n=0; n<generates.size(); n++){
			gene = &generates[n];
			if (!gene->nom.compare(s))
				erreur("<generate %s>: La commande <generate> n%d voulait dj "
				       "crer le fichier %s, or il est impossible de crer deux "
				       "fois le mme fichier dans le mme fichier .prehtml",
				       s,n,s);
		}
		/* on va vrifier que le fichier "suite" est bien vide
		 * Attention: il faut avoir t cr avec "w+" !*/
		fseek(sortie,0,SEEK_SET);
		while(1){
			i=getc(sortie);
			if (i==EOF) break;
			if (!strchr(" \t\n\r",i)) 
				erreur("<GENERATE %s> alors que des caractres non-blancs ('%c') "
				       "sont passs depuis le dernier </GENERATE>",s,i);
		}
		fclose(sortie); /* si c'est bon, on ferme et on efface le fichier de fin */
		unlink(nomfinfichier);
		remplitgenerate(s);
		engenerate=1;
	}
	else erreur("Erreur interne dans genere(): engenerate=%d",engenerate);
}

void degenere(void){ /* fonction appele quand </generate> arrive */
	if (engenerate==0) erreur("</GENERATE> sans aucun <GENERATE> avant");
	else if (engenerate==2) 
		erreur("</GENERATE> trouv alors qu'il y en a dj eu un avant");
	else if (engenerate==1){ /* OK, on est bien dans un <GENERATE>*/
		fclose(sortie);
		strcpy(nomfinfichier,NOMFINFICHIER);
		mkstemp(nomfinfichier);
		creetemp(nomfinfichier); /* fichier  effacer si arrt d'urgence */
		sortie=fopen(nomfinfichier,"w+"); /* le "+" est indispensable, on va le relire*/
		if (!sortie) erreur("</GENERATE>: pas pu crer le fichier de fin %s",
		                    nomfinfichier);
		engenerate=2;
	}
	else erreur("Erreur interne dans degenere(): engenerate=%d",engenerate);
}

void fin_generate(void){ /* choses  faire  la fin du fichier principal pour
	 * finaliser les <GENERATE> ventuels */
	char fichtempgene[]="/tmp/fichtempgenerateXXXXXX";
	FILE *fin,*fout,*f1,*f2;
	generate *gene;
	int i,i1,i2;

	if (engenerate==0) return; /* rien  faire */
	if (engenerate==1) erreur("EOF rencontr  l'intrieur d'un <GENERATE>");
	/* donc engenerate==2: on a des choses  faire */
	mkstemp(fichtempgene);
	creetemp(fichtempgene); /* fichier  effacer si arrt d'urgence */
	for (size_t n=0; n<generates.size(); n++){ /* on parcourt tous les fichiers gnrs */
		gene = &generates[n];
		fout=fopen(fichtempgene,"wb");
		if (!fout)erreur("Finalisation des <generate>: impossible de crer %s",
		                 fichtempgene);
		fin=fopen(fich_temp.c_str(),"rb"); /* c'est finalement le fichier de dbut */
		if (!fin)erreur("Finalisation des <generate>: impossible de lire "
		                "le dbut dans %s",fich_temp.c_str());
		while ((i=fgetc(fin))!=EOF) putc(i,fout);
		fclose(fin);
		fin=fopen(gene->nomtemp.c_str(),"rb"); /* milieu */
		if (!fin)erreur("Finalisation des <generate>: impossible de lire "
		                "le milieu dans %s",gene->nomtemp.c_str());
		while ((i=fgetc(fin))!=EOF) putc(i,fout);
		fclose(fin);
		unlink(gene->nomtemp.c_str());
		fin=fopen(nomfinfichier,"rb"); /* fin */
		if (!fin)erreur("Finalisation des <generate>: impossible de lire "
		                "la fin dans %s",nomfinfichier);
		while ((i=fgetc(fin))!=EOF) putc(i,fout);
		fclose(fin);
		fclose(fout);
		/* on va comparer le fichier cr avec celui existant [s'il existe] */
		f1=fopen(gene->nom.c_str(),"rb");
		i1=0;i1=1;
		if (f1){
			f2=fopen(fichtempgene,"rb");
			if (!f2) erreur("Le fichier %s n'a pas t cr",fichtempgene);
			do{
				i1=getc(f1); i2=getc(f2);
			}while(i1==i2 && i1!=EOF);
			fclose(f2);fclose(f1);
		}
		if (i1!=i2 || forcewrite){
			if (rename(fichtempgene,gene->nom.c_str()))
				erreur("Fin GENERATE: Impossible de renommer %s en %s",
				       fichtempgene,gene->nom.c_str());
		}
		else unlink(fichtempgene); /* fichiers identiques: je l'enlve
		 * pour ne pas changer la date */
	}
	unlink(fich_temp.c_str()); /* n'a plus d'utilit, ce n'tait que le dbut */
	unlink(nomfinfichier); /* n'a plus d'utilit, ce n'tait que la fin */
}
