#include "prehtml.h"

int debug=0;
int structure=0;
int shell=0;
int bits8=0; // 0 = 7 bits (codes HTML), 1 = 8 bits (iso-8859-1), 2 = 8 bits (UTF-8)
const char *shell_command="sh"; // shell  utiliser (bourne-shell par dfaut)
bool forcewrite=false; // force l'criture mme si le fichier de sortie est inchang

void init_traitement_fichier(void){ /* initialisation avant traitement fichier*/
	/* on initialise l'imbrication */
	ouvre_imbrique();
	imbriqueactu->type = imbrique::MAIN;
	/* on dfinit une fonction pour sparer les arguments shell */
	string macro="liste_shell() { while [ $# -gt 0 ]; do echo $1; shift; done; }";
	execshell(macro);
}

void traite_fichier_principal(void){ /* fait tout ce qu'il y a  faire */
	int c,i;
	/* initialisations */
	chut=0;
	affiche=1;
	while(1){ // boucle principale: lecture du fichier source
		c=decode();
		if (c==EOF){ // fin du fichier, on vrifie qu'il n'y a pas d'imbrication
			i=imbriqueactu->type;
			if (i!=imbrique::MAIN) erreur("EOF rencontr alors qu'on est dans un bloc <%s>",
			                              (i==imbrique::IF?"if":(i==imbrique::FOR?"for":(i==imbrique::WHILE?"while":
				                                                                             "inconnu")))
			                              );
			break; /* fin de fichier sans problme: on sort de la boucle*/
		}
		if (c!=EST_FONCTION) {/* caractre normal*/
			put(c);
			continue;
		}
		/* donc on est l en face d'une fonction */
		traitefonction();
	}
}

string fich_out,fich_temp;

void fait_tout_ce_qu_il_faut_pour_un_fichier(char *nom){
	int i,pc,dec;
	FILE *f1,*f2;
	int i1,i2;
	string ligne;

	init_pipe();
	ouvrir_fichier(nom);
	i=strlen(nom);dec=0;
	if (!strcasecmp(nom+i-5,".phtm")) {pc=i-4;dec=1;}
	else if (!strcasecmp(nom+i-6,".phtml")) {pc=i-5;dec=1;}
	else if (!strcasecmp(nom+i-7,".prehtm")) {pc=i-6;dec=3;}
	else if (!strcasecmp(nom+i-8,".prehtml")) {pc=i-7;dec=3;}
	else erreur("Le fichier \"%s\" n'est ni .phtm ni .phtml",nom);
	fich_out=nom;
	fich_out.erase(pc,dec); /* transforme en .htm ou .html */
	/* j'enregistre le nom du fichier de sortie dans $dest */
	ligne = "dest='"+fich_out+"'"; envoieshell(ligne);
	while(recoitshell(ligne,0));
	fich_temp = fich_out+".tmp";
	creetemp(fich_temp.c_str()); /* fichier  effacer si arrt d'urgence */
	sortie=fopen(fich_temp.c_str(),"w"); /* on cre un fichier temporaire */
	if (!sortie) erreur("Impossible de crer le fichier %s",fich_temp.c_str());
	init_generate(); /* indispensable pour que GENERATE marche */
	init_traitement_fichier();
	traite_fichier_principal();
	fin_pipe(); /*  refermer pour qu'on puisse recommencer */
	fclose(sortie);
	fin_generate(); /* conclut le traitement des GENERATE */
	if (engenerate==0){ /* si on a fait GENERATE, c'est trait dans generate.c */
		/* on compare l'ancien (si existant) et le nouveau fichier */
		f1=fopen(fich_out.c_str(),"rb");
		i1=0;i1=1;
		if (f1){
			f2=fopen(fich_temp.c_str(),"rb");
			if (!f2) erreur("Le fichier %s n'a pas t cr",fich_temp.c_str());
			do{
				i1=getc(f1); i2=getc(f2);
			}while(i1==i2 && i1!=EOF);
			fclose(f2);fclose(f1);
		}
		if (i1!=i2 || forcewrite){
			if (rename(fich_temp.c_str(),fich_out.c_str()))
				erreur("Impossible de renommer %s en %s",fich_temp.c_str(),fich_out.c_str());
		}
		else unlink(fich_temp.c_str()); /* fichiers identiques: je l'enlve
		 * pour ne pas changer la date */
	}
}

int main(int argc,char *argv[]){
	if (argc<2 || (argc>=2 && ((!strcmp(argv[1],"-h")) || (!strcmp(argv[1],"--help"))))) {
		message("prehtml v2.6: Syntaxe: prehtml [options] <fichier(s).prehtml>\n"
		        "-d : debug, sortie galement dans stdout\n"
		        "-s : structure, affiche le dtail des fichiers dans lesquels on rentre\n"
		        "-S : Shell, affiche les commandes Shell effectues\n"
		        "-b <bash,...> : Bash, appelle un shell autre que \"sh\"\n"
		        "-8 : 8 bits, ne transforme pas les caractres 8 bits en codes HTML\n"
		        "     transforme les codes HTML en caractres 8 bits (iso-8859-1)\n"
		        "-u : comme -8, mais transforme les codes HTML en caractres UTF-8\n"
		        "-f : force l'criture du fichier de sortie, mme s'il est inchang\n"
		        "-h  --help : cette aide\n");
		return 1;
	}
	argc--;
	while (argc--){
		argv++;
		if (*argv[0] == '-'){
			argv[0] ++;
			while (**argv){
				if (**argv=='d'){
					debug=1;
					message("prehtml: option \"debug\" (-d) active\n");
				}
				else if (**argv=='s'){
					structure=1;
					message("prehtml: option \"structure\" (-s) active\n");
				}
				else if (**argv=='S'){
					shell=1;
					message("prehtml: option \"Shell\" (-S) active\n");
				}
				else if (**argv=='b'){
					if (argv[0][1]){
						shell_command=&argv[0][1];
						argv[0]+=strlen(argv[0])-1;
					}
					else if (argv[1]){
						argv++;
						argc--;
						shell_command=argv[0];
						argv[0]+=strlen(argv[0])-1;
					} else
						erreur("prehtml: paramtre <bash,...> manquant aprs option \"-b\"\n");
					message("prehtml: option \"bash\" (-b) active, avec le shell \"%s\"\n", shell_command);
				}
				else if (**argv=='8'){
					bits8=1;
					message("prehtml: option \"8 bits iso-8859-1\" (-8) active\n");
				}
				else if (**argv=='u'){
					bits8=2;
					message("prehtml: option \"8 bits UTF-8\" (-u) active\n");
				}
				else if (**argv=='f'){
					forcewrite=true;
				}
				else if (**argv=='h'){
					main(0, NULL); // affiche l'aide
				}
				else {
					message("prehtml: Option -%c inconnue!\n",**argv);
					return 1;
				}
				argv[0] ++;
			}
			continue;
		}
		/*    if (!strcmp(*argv,"-d")){
			debug=1;
			continue;
	}
	if (!strcmp(*argv,"-s")){
		structure=1;
		continue;
	}*/
		fait_tout_ce_qu_il_faut_pour_un_fichier(*argv);
	}
	return 0;
}

